;peek.asm, makes peek.dll

comment| A make-file for peek.dll:
@echo off
echo LIBRARY peek>peektemp.def
echo EXPORTS info>>peektemp.def
echo EXPORTS regs>>peektemp.def
echo EXPORTS mem>>peektemp.def
\masm32\bin\ml /c /coff peek.asm
if errorlevel 1 goto end
\masm32\bin\Link /SUBSYSTEM:WINDOWS /STACK:4096,4096 /HEAP:4096,4096 /DLL /DEF:peektemp.def peek.obj
del peek.obj
dir peek.dll
:end
del peektemp.def
|

.686
.model flat, stdcall
option casemap:none
public info
public regs
public mem

@h equ dword ptr[ebp+10h]  ;hWnd, uMsg, etc. after a dialog procedure sets up
@u equ dword ptr[ebp+14h]
@ul equ word ptr[ebp+14h]
@w equ dword ptr[ebp+18h]
@wl equ word ptr[ebp+18h]
@l equ dword ptr[ebp+1Ch]

;control id's:
IdResume equ 1
IdQuit equ 2
IdEditBox equ 3
IdListView equ 4

ItemCount equ 15  ;8 registers and 7 flags in the regs output

;dialog box metrics, in dialog box units:
HeightBtn equ 0Eh
WidthRegDlg equ 78h
HeightRegDlg equ 98h
WidthMemDlg equ 120h
HeightMemDlg equ 90h
WidthRegBtn equ WidthRegDlg/2
WidthMemBtn equ WidthMemDlg/2

;style bits:
WS_TABSTOP          equ    10000h
WS_DLGFRAME         equ   400000h
WS_BORDER           equ   800000h
WS_VISIBLE          equ 10000000h
WS_CHILD            equ 40000000h
WS_POPUP            equ 80000000h
WS_EX_NOPARENTNOTIFY equ 4
WS_EX_CLIENTEDGE equ 200h
LVS_REPORT equ 1
BS_DEFPUSHBUTTON equ 1
DS_CENTER equ 800h
DS_MODALFRAME equ 80h

;messages:
WM_SETFONT     equ 30h
WM_SETTEXT     equ 0Ch
WM_CLOSE       equ 10h
WM_INITDIALOG  equ 110h
LVIF_TEXT      equ 1
LVM_INSERTITEM   equ 1007h
LVM_INSERTCOLUMN equ 101Bh
LVM_SETITEMTEXT  equ 102Eh
LVM_SETITEMCOUNT equ 102Fh

include \masm32\include\kernel32.inc  ;only for ExitProcess
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc  ;only for InitCommonControls
include \masm32\include\gdi32.inc     ;only for GetStockObject
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\gdi32.lib

.data
databegins label dword
hInst dd ?
hListView dd 0
hFont dd 0
hEditBox dd ?
dInitCommonControls dd InitCommonControls ;SysListView32 requires this call
ColSize0 dd ?
ColSize1or2 dd ?

RegItem label dword    ;instead of this table, a local structure could be used
                dd 0Fh    ;mask: 4 valid fields follow
          iItem dd ?
                dd 0       ;column if >0
                dd 0,0     ;state, statemask
       ItemText dd ?
                dd 10h     ;text max
                dd 0,0

MemWindowName$ db "Memory from "
   MemDumpSite db 9 dup (0)

.code
info dd 3,databegins,regs,mem   ;count, data base, and routine addresses
ItemNames label dword
    dd "XAE","XBE","XCE","XDE"  ;We use dd rather than db to get the zeros.
    dd "ISE","IDE","PBE","PSE","FC ","FP ","FA ","FZ ","FS ","FD ","FO "
MemDlgTemplate dd WS_POPUP+WS_DLGFRAME+WS_BORDER+DS_CENTER+DS_MODALFRAME
    dd 0 ;exStyle, should be zero when the default dialog window class is used
    dw 3     ;num items
    dw 0, 0, WidthMemDlg, HeightMemDlg
    dw 0, 0
    dw 0 ;Unicode caption, initially null
align 4   ;dialog item 1 of 3:
    dd WS_CHILD+WS_VISIBLE+WS_TABSTOP+BS_DEFPUSHBUTTON
    dd 0    ;exstyle
    dw WidthMemBtn,HeightMemDlg-HeightBtn,WidthMemBtn,HeightBtn
    dw IdResume
    dw -1,80h
    dw "R","e","s","u","m","e",0     ;Unicode button label
    dw 0          ;dialog items have 16-bit zero terminator
align 4   ;dialog item 2:
    dd WS_CHILD+WS_VISIBLE+WS_TABSTOP
    dd 0
    dw 0,HeightMemDlg-HeightBtn,WidthMemBtn,HeightBtn
    dw IdQuit
    dw -1,80h
    dw "Q","u","i","t",0
    dw 0
align 4   ;dialog item 3, a multi-line read-only edit box:
    dd 54000824h ;WS_various+ES_MULTILINE+ES_READONLY+DS_LOCALEDIT
    dd WS_EX_NOPARENTNOTIFY+WS_EX_CLIENTEDGE
    dw 0,0,WidthMemDlg,HeightMemDlg-HeightBtn
    dw IdEditBox
    dw -1,81h     ;predefined class, EDIT
    dw 0       ;no text initially
    dw 0

align 4
RegDlgTemplate dd WS_POPUP+WS_DLGFRAME+WS_BORDER+DS_CENTER+DS_MODALFRAME, 0
    dw 3     ;num items
    dw 0, 0, WidthRegDlg, HeightRegDlg
    dw 0, 0  ;menu (none) and class (default)
    dw "R","e","g","i","s","t","e","r","s",0
align 4   ;dialog item 1 of 3:
    dd WS_CHILD+WS_VISIBLE+WS_TABSTOP+BS_DEFPUSHBUTTON
    dd 0    ;exstyle
    dw WidthRegBtn,HeightRegDlg-HeightBtn,WidthRegBtn,HeightBtn
    dw IdResume
    dw -1,80h     ;predefined class, BUTTON
    dw "R","e","s","u","m","e",0
    dw 0      ;terminator
align 4   ;dialog item 2:
    dd WS_CHILD+WS_VISIBLE+WS_TABSTOP  ;low word zero indicates a pushbutton
    dd 0
    dw 0,HeightRegDlg-HeightBtn,WidthRegBtn,HeightBtn
    dw IdQuit
    dw -1,80h
    dw "Q","u","i","t",0
    dw 0      ;terminator
align 4   ;dialog item 3, a list view control:
    dd WS_VISIBLE or WS_CHILD or LVS_REPORT
    dd WS_EX_NOPARENTNOTIFY
    dw 0,0,WidthRegDlg,HeightRegDlg-HeightBtn
    dw IdListView
    dw "S","y","s","L","i","s","t","V","i","e","w","3","2",0  ;class
    dw 0      ;no caption or other text
    dw 0      ;terminator

Header1$ db "Hex",0
Header2$ db "Decimal",0

Start:           ;Called by the operating system on the attachment
    pop ecx      ;      or detachment of any process or thread.
    pop eax
    pop edx
    dec edx    ;1 = DLL_PROCESS_ATTACH
    pop edx
    jnz short @F
    mov hInst,eax  ;Module handle (=base address) of the dll, not the exe.
@@: mov eax,1    ;Returning 1 indicates success, 0 aborts loading of the dll.
JmpECX: jmp ecx

;procedure exit code
CloseAnyDlg:
    invoke EndDialog,@h,0
Done1:
    mov eax,1
    jmp short Done
Done0:
    xor eax,eax
Done:
    leave
    pop edi
    pop esi
    retn 10h
JmpDefWndProc:  ;Unload the stack and jmp (not call) DefWindowProc.
    leave       ;The same move can sometimes be used with SendMessage.
    pop edi
    pop esi
    jmp DefWindowProc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
regs:
    pushad
    pushfd
    mov eax,esp
    push eax    ;use lparam to point at the caller's registers
    push offset DlgProcReg
    push 0      ;no parent window
    push offset RegDlgTemplate
    cld
    push hInst
    call DialogBoxIndirectParam
    popfd
    popad
    ret
mem:
    pushad
    pushfd
    lea eax,[esp+28h]
    push eax    ;use lparam to point at the caller's input (base and amount)
    push offset DlgProcMem
    push 0      ;no parent window
    push offset MemDlgTemplate
    cld
    push hInst
    call DialogBoxIndirectParam
    popfd
    popad
    ret 8
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DlgProcMem:
    mov ecx,offset mem_INITDIALOG ;the two dlg proc's are the same apart from WM_INITDIALOG
    jmp short DlgProcCommon
DlgProcReg:
    mov ecx,offset reg_INITDIALOG
DlgProcCommon:
    push esi
    push edi
    push ebp
    mov ebp,esp
    mov eax,@u
    sub eax,WM_CLOSE
    jz CloseAnyDlg
    sub eax,WM_INITDIALOG-WM_CLOSE
    jz JmpECX
    dec eax
    jnz Done0     ;WM_COMMAND-WM_INITDIALOG = 1
    movzx eax,@wl
    dec eax   ;IdResume=1
    jz CloseAnyDlg
    dec eax   ;IdQuit=2
    jnz Done0
    invoke ExitProcess,eax

reg_INITDIALOG:
    call MaybeInitCommonControls
    call GetDialogBaseUnits
    movzx eax,ax
    shl eax,2         ;get width of 4 chars in pixels
    mov ColSize0,eax
    push eax
    sub esp,10h
    mov eax,esp
    invoke GetClientRect,@h,eax
    pop iItem  ;0
    pop eax
    pop eax  ;client width in pixels
    pop edx
    pop edx  ;ColSize0
    sub eax,edx
    shr eax,1
    mov ColSize1or2,eax
    mov ItemText,offset ItemNames
    invoke GetDlgItem,@h,IdListView
    mov hListView,eax
    xchg eax,esi
    call GetFixedFont
    invoke SendMessageA,esi,WM_SETFONT,eax,0   ;lparam=1 to redraw, else 0
    invoke SendMessageA,esi,LVM_SETITEMCOUNT,ItemCount,0
    xor eax,eax
    push eax      ;build an LV_COLUMN structure
    push eax      ;buff size, not needed here
    push eax      ;lpsz heading, or 0 for none
    push ColSize0 ;width
    push eax      ;alignment, LVCFMT_LEFT. The leftmost column must be left-aligned.
    push 0Fh      ;mask: 4 fields in the LV_COLUMN are meaningful
    mov edi,esp
    invoke SendMessageA,esi,LVM_INSERTCOLUMN,eax,edi
    add esp,10h        ;discard the bottom four fields of the LV_COLUMN
    push offset Header1$    ;push a new set of four
    push ColSize1or2
    push 0
    push 0Fh
    invoke SendMessageA,esi,LVM_INSERTCOLUMN,1,edi
    add esp,10h
    push offset Header2$
    push ColSize1or2
    push 1         ;LVCFMT_RIGHT
    push 0Fh
    invoke SendMessageA,esi,LVM_INSERTCOLUMN,2,edi
    mov edi,ItemCount
@@: invoke SendMessageA,esi,LVM_INSERTITEM,0,addr RegItem
    inc iItem
    add ItemText,4
    dec edi
    jnz short @B
    mov iItem,edi ;reset to zero
    mov ebx,@l
    lea eax,[ebx+28h] ;caller's esp before "call regs" pushed a return address
    push eax          ;stack up the caller's 8 registers in the reverse of
    push [ebx+0Ch]    ;   the order in which we will display them
    push [ebx+4]
    push [ebx+8]
    push [ebx+18h]
    push [ebx+1Ch]
    push [ebx+14h]
    push [ebx+20h]
    mov esi,8         ;a counter
@@: call RegRoutine
    dec esi
    jnz @B
    push 11    ;stack up data for seven LVM_SETITEMTEXT messages
    push 10    ;these numbers give the location of various bits
    push 7     ;    in the flags register
    push 6
    push 4
    push 2
    push esi     ;0
    add esi,7      ;cheaper than mov esi,7
    mov edi,[ebx]  ;caller's flags
@@: pop ecx
    bt edi,ecx
    sbb eax,eax
    neg eax
    add al,"0"
    push eax     ;put a one-byte asciiz string on the stack
    mov eax,esp  ;point at it
    push 4    ;textmax, first of seven pushes that make an abbreviated LV_ITEM structure
    push eax
    xor eax,eax
    push eax
    push eax
    push 1       ;subitem, i.e. 1-based column
    push eax
    push LVIF_TEXT
    mov eax,esp
    invoke SendMessageA,hListView,LVM_SETITEMTEXT,iItem,eax
    add esp,20h
    inc iItem
    dec esi
    jnz @B
    jmp Done1

mem_INITDIALOG:
    invoke GetDlgItem,@h,IdEditBox
    mov hEditBox,eax
    xchg eax,esi
    call GetFixedFont
    invoke SendMessageA,esi,WM_SETFONT,eax,0
    mov esi,@l       ;lparam points at the caller's two input dwords
    mov eax,[esi+4]  ;amount requested
    mov ecx,100h
    test eax,eax
    cmovz eax,ecx    ; db 0Fh,44h,0C1h
    cmp eax,ecx
    cmova eax,ecx    ;db 0Fh,47h,0C1h
    mov @l,eax       ;gets decremented
    lodsd            ;or mov eax,[esi], load address from which to read memory
    mov esi,eax
    mov edi,offset MemDumpSite
    call WriteEaxHex
    invoke SendMessageA,@h,WM_SETTEXT,0,addr MemWindowName$
    sub esp,1076  ;room for 16 lines of 48+1+16+2 bytes each, plus a terminal 0
    mov edi,esp
mem_outerloop:       ;writes one line of output to the edit box
    push 10h
    pop ebx       ;a counter
    push 0Ch
    pop ecx
    mov eax,"    "  ;write 49 spaces -- the hex part of one line of output
    push edi
    rep stosd
    stosb
    mov ecx,edi     ;point ecx at the ascii part of the output line
    pop edi
mem_innerloop:
    lodsb            ;get a byte from memory
    mov dl,"."
    test al,al
    js short @F
    cmp al," "
    cmovnb edx,eax   ;db 0Fh,43h,0D0h
@@: mov [ecx],dl     ;poke the ascii character
    inc ecx
    call al2hexax
    stosw            ;poke the two-byte hex dump of the same character
    inc edi          ;bypass one space
    dec @l
    jz @F
    dec ebx
    jnz mem_innerloop
    mov word ptr[ecx],0A0Dh ;unlike message boxes, edit controls use CR+LF.
    add edi,13h           ;bypass one space, 16 ascii chars, and CRLF
    jmp mem_outerloop
@@: mov byte ptr[ecx],0
    mov eax,esp
    invoke SendMessageA,hEditBox,WM_SETTEXT,0,eax
    jmp Done1

RegRoutine:  ;{value}
    enter 0Ch,0   ;make room to dump eax in hex
    mov eax,[ebp+8]
    mov edi,esp
    call WriteEaxHex     ;loses edi
    mov eax,esp
    push 0Ch     ;textmax
    push eax     ;lptext
    xor eax,eax
    push eax
    push eax     ;state
    push 1
    push eax
    push LVIF_TEXT
    mov eax,esp
    invoke SendMessageA,hListView,LVM_SETITEMTEXT,iItem,eax
    mov edi,esp    ;there are now 28h bytes of local space, more than enough
    mov eax,[ebp+8]
    call WriteEaxDecimal
    mov eax,esp
    push 10h
    push eax
    xor eax,eax
    push eax     ;state mask
    push eax     ;state
    push 2       ;1-based subitem, i.e. 0-based column
    push eax     ;item (i.e. 0-based row), not used in LVM_SETITEMTEXT
    push LVIF_TEXT
    mov eax,esp
    invoke SendMessageA,hListView,LVM_SETITEMTEXT,iItem,eax
    leave
    inc iItem
    ret 4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
al2hexax:
    mov ah,al
    shr ah,4
    call @F
    xchg al,ah
@@: and al,0Fh
    cmp al,0Ah
    sbb al,69h
    das
    ret

WriteEaxDecimal:
    push 0Ah    ;decimal radix
    pop ecx
    call @F
    mov [edi],ch
    ret
@@: xor edx,edx  ;a classic reentrant routine
    div ecx
    push edx
    or eax,eax
    jz short @F
    call @B
@@: pop eax
    or al,"0"
    stosb
    ret

WriteEaxHex:
    push 4        ;number of bytes in eax
    pop ecx
@@: rol eax,8
    push eax
    call al2hexax
    stosw
    pop eax
    loop @B
    mov [edi],cl   ;0
    ret

MaybeInitCommonControls:
    mov eax,offset AnyRet
    xchg eax,dInitCommonControls
    jmp eax

GetFixedFont:
    mov eax,hFont
    test eax,eax
    jnz short AnyRet
    invoke GetStockObject,10h      ;SYSTEM_FIXED_FONT
    mov hFont,eax
AnyRet: ret
end Start
